import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Panel;

public class BorderPanel extends Panel {
   protected int shadow = 4;
   protected boolean raised = true;

   public BorderPanel() {
      this.raised = true;
   }

   public BorderPanel(boolean var1) {
      this.raised = var1;
   }

   protected void layoutParent() {
      Container var1 = ((Component)this).getParent();
      if (var1 != null) {
         var1.doLayout();
      }

   }

   public void paint(Graphics var1) {
      super.paint(var1);
      Dimension var2 = ((Component)this).getSize();
      this.paintBorder(var1, var2);
   }

   protected void paintBorder(Graphics var1, Dimension var2) {
      Color var3 = ((Component)this).getBackground();
      var1.setColor(var3);
      var1.fillRect(0, 0, var2.width, var2.height);
      this.draw3DRect(var1, 0, 0, var2.width, var2.height, this.raised);
   }

   public void draw3DRect(Graphics var1, int var2, int var3, int var4, int var5, boolean var6) {
      Color var7 = var1.getColor();
      Color var8 = avgColor(var7, Color.white);
      Color var9 = avgColor(var7, Color.black);
      var1.setColor(var6 ? var8 : var9);

      for(int var10 = 0; var10 < this.shadow; ++var10) {
         var1.drawLine(var2 + var10, var3 + var10, var2 + var4 - 1 - var10, var3 + var10);
         var1.drawLine(var2 + var10, var3 + var10, var2 + var10, var3 + var5 - 1 - var10);
      }

      var1.setColor(var6 ? var9 : var8);

      for(int var11 = 0; var11 < this.shadow; ++var11) {
         var1.drawLine(var2 + var11, var3 + var5 - 1 - var11, var2 + var4 - 1 - var11, var3 + var5 - 1 - var11);
         var1.drawLine(var2 + var4 - 1 - var11, var3 + var5 - 1 - var11, var2 + var4 - 1 - var11, var3 + var11);
      }

      var1.setColor(var7);
      var1.setColor(Color.black);
      var1.drawRect(var2, var3, var4 + 2, var5 + 2);
   }

   public static Color avgColor(Color var0, Color var1) {
      return new Color((var0.getRed() + var1.getRed()) / 2, (var0.getGreen() + var1.getGreen()) / 2, (var0.getBlue() + var1.getBlue()) / 2);
   }
}
