import java.awt.Color;
import java.awt.Component;
import java.awt.Event;
import java.awt.Graphics;
import java.awt.Panel;
import java.awt.Rectangle;
import java.util.Vector;

class DrawPanel extends Panel {
   public static final int LINES = 0;
   public static final int POINTS = 1;
   int mode;
   Vector lines = new Vector();
   Vector colors = new Vector();
   // $FF: renamed from: x1 int
   int field_0;
   // $FF: renamed from: y1 int
   int field_1;
   // $FF: renamed from: x2 int
   int field_2;
   // $FF: renamed from: y2 int
   int field_3;
   // $FF: renamed from: xl int
   int field_4;
   // $FF: renamed from: yl int
   int field_5;

   public DrawPanel() {
      ((Component)this).setBackground(Color.white);
   }

   public void setDrawMode(int var1) {
      switch (var1) {
         case 0:
         case 1:
            this.mode = var1;
            return;
         default:
            throw new IllegalArgumentException();
      }
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 201:
            System.exit(0);
            return true;
         case 501:
            switch (this.mode) {
               case 0:
                  this.field_0 = var1.x;
                  this.field_1 = var1.y;
                  this.field_2 = -1;
                  break;
               case 1:
               default:
                  this.colors.addElement(((Component)this).getForeground());
                  this.lines.addElement(new Rectangle(var1.x, var1.y, -1, -1));
                  this.field_0 = var1.x;
                  this.field_1 = var1.y;
                  ((Component)this).repaint();
            }

            return true;
         case 502:
            switch (this.mode) {
               case 0:
                  this.colors.addElement(((Component)this).getForeground());
                  this.lines.addElement(new Rectangle(this.field_0, this.field_1, var1.x, var1.y));
                  this.field_2 = this.field_4 = -1;
               case 1:
               default:
                  ((Component)this).repaint();
                  return true;
            }
         case 506:
            switch (this.mode) {
               case 0:
                  this.field_4 = this.field_2;
                  this.field_5 = this.field_3;
                  this.field_2 = var1.x;
                  this.field_3 = var1.y;
                  break;
               case 1:
               default:
                  this.colors.addElement(((Component)this).getForeground());
                  this.lines.addElement(new Rectangle(this.field_0, this.field_1, var1.x, var1.y));
                  this.field_0 = var1.x;
                  this.field_1 = var1.y;
            }

            ((Component)this).repaint();
            return true;
         default:
            return false;
      }
   }

   public void paint(Graphics var1) {
      int var2 = this.lines.size();
      var1.setColor(((Component)this).getForeground());
      var1.setPaintMode();

      for(int var3 = 0; var3 < var2; ++var3) {
         Rectangle var4 = (Rectangle)this.lines.elementAt(var3);
         var1.setColor((Color)this.colors.elementAt(var3));
         if (var4.width != -1) {
            var1.drawLine(var4.x, var4.y, var4.width, var4.height);
         } else {
            var1.drawLine(var4.x, var4.y, var4.x, var4.y);
         }
      }

      if (this.mode == 0) {
         var1.setXORMode(((Component)this).getBackground());
         if (this.field_4 != -1) {
            var1.drawLine(this.field_0, this.field_1, this.field_4, this.field_5);
         }

         var1.setColor(((Component)this).getForeground());
         var1.setPaintMode();
         if (this.field_2 != -1) {
            var1.drawLine(this.field_0, this.field_1, this.field_2, this.field_3);
         }
      }

   }
}
