import java.awt.Graphics;

class HighlightArea extends ImageMapArea {
   int hlmode;
   int hlpercent;

   public void handleArg(String var1) {
      if (var1 == null) {
         this.hlmode = super.parent.hlmode;
         this.hlpercent = super.parent.hlpercent;
      } else {
         if (var1.startsWith("darker")) {
            this.hlmode = 1;
            var1 = var1.substring("darker".length());
         } else {
            this.hlmode = 0;
            if (var1.startsWith("brighter")) {
               var1 = var1.substring("brighter".length());
            }
         }

         this.hlpercent = Integer.parseInt(var1);
      }
   }

   public void makeImages() {
      ((ImageMapArea)this).setHighlight(super.parent.getHighlight(super.X, super.Y, super.W, super.H, this.hlmode, this.hlpercent));
   }

   public void highlight(Graphics var1) {
      if (super.entered) {
         var1.drawImage(super.hlImage, super.X, super.Y, this);
      }

   }

   public void enter() {
      ((ImageMapArea)this).repaint();
   }

   public void exit() {
      ((ImageMapArea)this).repaint();
   }
}
