import java.awt.image.RGBImageFilter;

class HighlightFilter extends RGBImageFilter {
   boolean brighter;
   int percent;

   public HighlightFilter(boolean var1, int var2) {
      this.brighter = var1;
      this.percent = var2;
      super.canFilterIndexColorModel = true;
   }

   public int filterRGB(int var1, int var2, int var3) {
      int var4 = var3 >> 16 & 255;
      int var5 = var3 >> 8 & 255;
      int var6 = var3 & 255;
      if (this.brighter) {
         var4 = 255 - (255 - var4) * (100 - this.percent) / 100;
         var5 = 255 - (255 - var5) * (100 - this.percent) / 100;
         var6 = 255 - (255 - var6) * (100 - this.percent) / 100;
      } else {
         var4 = var4 * (100 - this.percent) / 100;
         var5 = var5 * (100 - this.percent) / 100;
         var6 = var6 * (100 - this.percent) / 100;
      }

      if (var4 < 0) {
         var4 = 0;
      }

      if (var4 > 255) {
         var4 = 255;
      }

      if (var5 < 0) {
         var5 = 0;
      }

      if (var5 > 255) {
         var5 = 255;
      }

      if (var6 < 0) {
         var6 = 0;
      }

      if (var6 > 255) {
         var6 = 255;
      }

      return var3 & -16777216 | var4 << 16 | var5 << 8 | var6;
   }
}
