import java.awt.Canvas;
import java.awt.Color;
import java.awt.Component;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Toolkit;

class SymbolCanvas extends Canvas {
   Font font;
   int charHeight;
   int charWidth;
   int charBase;

   public SymbolCanvas(Font var1, int var2) {
      FontMetrics var3 = Toolkit.getDefaultToolkit().getFontMetrics(var1);
      this.charHeight = var3.getHeight() + 3;
      this.charWidth = var3.getMaxAdvance() + 4;
      this.charBase = var2;
      ((Component)this).setSize(this.charWidth * 16 + 60, this.charHeight * 16 + 10);
   }

   public void setBase(int var1) {
      this.charBase = var1;
      ((Component)this).repaint();
   }

   public void setFont(Font var1) {
      this.font = var1;
      ((Component)this).repaint();
   }

   public void paint(Graphics var1) {
      var1.setFont(this.font);
      var1.setColor(Color.black);
      char[] var2 = new char[1];
      int var3 = this.charBase;
      int var4 = 20;

      for(int var5 = 0; var5 < 16; ++var5) {
         var1.drawString(Integer.toHexString(var3), 10, var4);
         int var6 = 60;

         for(int var7 = 0; var7 < 16; ++var7) {
            var2[0] = (char)(var3++);
            var1.drawChars(var2, 0, 1, var6, var4);
            var6 += this.charWidth;
         }

         var4 += this.charHeight;
      }

   }
}
