import java.awt.BorderLayout;
import java.awt.Choice;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Font;
import java.awt.Frame;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextArea;
import java.awt.Window;
import java.awt.event.InputEvent;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.text.BreakIterator;
import java.util.EventObject;

class TextBoundFrame extends Frame implements WindowListener, ItemListener, KeyListener {
   private static final String creditString = "v1.1a9, Demo";
   private static final String copyrightString = "";
   private static final String copyrightString2 = "";
   private static final int FIELD_COLUMNS = 45;
   private static final Font choiceFont = null;
   private static final boolean DEBUG = false;
   private DemoApplet applet;
   final String right = "-->";
   final String left = "<--";
   // $FF: renamed from: enum java.text.BreakIterator
   private BreakIterator field_0;
   TextArea text;
   Choice bound;

   public TextBoundFrame(DemoApplet var1) {
      this.applet = var1;
      ((Window)this).addWindowListener(this);
      this.init();
      this.start();
   }

   public void run() {
   }

   public int getSelectionStart() {
      return this.text.getSelectionStart() & 32767;
   }

   public int getSelectionEnd() {
      return this.text.getSelectionEnd() & 32767;
   }

   public synchronized void checkChange() {
      int var1 = this.field_0.following(this.getSelectionStart());
      int var2 = this.field_0.previous();
      this.selectRange(var2, var1);
   }

   public final synchronized void selectRange(int var1, int var2) {
      try {
         this.text.select(var1, var2);
         if (this.getSelectionStart() != var1 || this.getSelectionEnd() != var2) {
            System.out.println("AGH! select(" + var1 + "," + var2 + ") -> (" + this.getSelectionStart() + "," + this.getSelectionEnd() + ")");
         }

      } catch (Exception var4) {
         this.errorText(((Throwable)var4).toString());
      }
   }

   public void init() {
      this.buildGUI();
   }

   public void start() {
   }

   void addWithFont(Container var1, Component var2, Font var3) {
      if (var3 != null) {
         var2.setFont(var3);
      }

      var1.add(var2);
   }

   public void buildGUI() {
      ((Component)this).setBackground(Color.white);
      ((Container)this).setLayout(new BorderLayout());
      Panel var1 = new Panel();
      Label var2 = new Label("Text Boundary Demo", 1);
      ((Component)var2).setFont(Utility.titleFont);
      ((Container)var1).add(var2);
      Label var3 = new Label("v1.1a9, Demo", 1);
      ((Component)var3).setFont(Utility.creditFont);
      ((Container)var1).add(var3);
      Panel var4 = new Panel();
      Label var5 = new Label("Boundaries", 0);
      ((Component)var5).setFont(Utility.labelFont);
      ((Container)var4).add(var5);
      this.bound = new Choice();
      this.bound.addItemListener(this);
      this.bound.addItem("Sentence");
      this.bound.addItem("Line Break");
      this.bound.addItem("Word");
      this.bound.addItem("Char");
      if (null != null) {
         this.bound.setFont((Font)null);
      }

      ((Container)var4).add(this.bound);
      ((Container)var1).add(var4);
      Utility.fixGrid(var1, 1);
      ((Container)this).add("North", var1);
      byte var6 = 15;
      byte var7 = 50;
      this.text = new TextArea(this.getInitialText(), var6, var7);
      this.text.addKeyListener(this);
      this.text.setEditable(true);
      this.text.selectAll();
      this.text.setFont(Utility.editFont);
      ((Container)this).add("Center", this.text);
      Panel var8 = new Panel();
      this.addWithFont(var8, new Label("", 0), Utility.creditFont);
      this.addWithFont(var8, new Label("", 0), Utility.creditFont);
      Utility.fixGrid(var8, 1);
      ((Container)this).add("South", var8);
      this.handleEnumChanged();
   }

   public String getInitialText() {
      return "(\"This is a complete sentence.\") This is (\"not.\") also. \nAn abbreviation in the middle, etc. and one at the end, etc. This\nis a simple sample 012.566,5 sentence. It doesn't\nhave to make any sense, as you can see. Nel mezzo del \ncammin di nostra vita, mi ritrovai in una selva oscura. Che\nla dritta via aveo smarrita. Not on my time (el timo.)! And\ntabulated columns: \tCol1\tCol2\t3,456%.\t\nIs this a question???  I wonder... Hmm. Harris thumbed\ndown several, including \"Away We Go\" (which became the \nhuge success Oklahoma!). One species, B. anthracis, is \nhighly virulent. Wolf said about Sounder: \"Beautifully \nthought-out and directed.\" Have you ever said, \"This is where I\nshall live\"? He said 1000,233,456.000 and answered, \"You may not!\" \nAnother popular saying is: \"How do you do?\". What is the \nproper use of the abbreviation pp.? Yes, I am 12' 3\" tall!!";
   }

   public void handleEnumChanged() {
      String var1 = this.bound.getSelectedItem();
      if (var1.equals("Char")) {
         this.errorText("getCharacterInstance");
         this.field_0 = BreakIterator.getCharacterInstance();
      } else if (var1.equals("Word")) {
         this.errorText("tWordBreak");
         this.field_0 = BreakIterator.getWordInstance();
      } else if (var1.equals("Line Break")) {
         this.errorText("getLineInstance");
         this.field_0 = BreakIterator.getLineInstance();
      } else {
         this.errorText("getSentenceInstance");
         this.field_0 = BreakIterator.getSentenceInstance();
      }

      this.field_0.setText(this.text.getText());
      this.selectRange(0, 0);
   }

   public void handleForward() {
      try {
         this.field_0.setText(this.text.getText());
         this.getSelectionStart();
         int var1 = this.getSelectionEnd();
         if (var1 < 1) {
            this.selectRange(0, this.field_0.following(0));
         } else {
            int var2 = this.field_0.following(var1 - 1);
            int var3 = this.field_0.next();
            if (var3 == -1) {
               var3 = var2;
            }

            this.selectRange(var2, var3);
         }
      } catch (Exception var4) {
         this.errorText(((Throwable)var4).toString());
      }
   }

   public void handleBackward() {
      try {
         this.field_0.setText(this.text.getText());
         int var1 = this.getSelectionStart();
         this.getSelectionEnd();
         if (var1 < 1) {
            this.selectRange(0, 0);
         } else {
            int var2 = this.field_0.following(var1 - 1);
            int var3 = this.field_0.previous();
            this.selectRange(var3, var2);
         }
      } catch (Exception var4) {
         this.errorText(((Throwable)var4).toString());
      }
   }

   public void itemStateChanged(ItemEvent var1) {
      if (((EventObject)var1).getSource() instanceof Choice) {
         this.handleEnumChanged();
      }

   }

   public void keyPressed(KeyEvent var1) {
      if (var1.getKeyCode() == 39) {
         ((InputEvent)var1).consume();
         this.handleForward();
      } else {
         if (var1.getKeyCode() == 37) {
            ((InputEvent)var1).consume();
            this.handleBackward();
         }

      }
   }

   public void keyReleased(KeyEvent var1) {
   }

   public void keyTyped(KeyEvent var1) {
   }

   public void windowClosed(WindowEvent var1) {
   }

   public void windowDeiconified(WindowEvent var1) {
   }

   public void windowIconified(WindowEvent var1) {
   }

   public void windowActivated(WindowEvent var1) {
   }

   public void windowDeactivated(WindowEvent var1) {
   }

   public void windowOpened(WindowEvent var1) {
   }

   public void windowClosing(WindowEvent var1) {
      ((Component)this).setVisible(false);
      ((Frame)this).dispose();
      if (this.applet != null) {
         this.applet.demoClosed();
      } else {
         System.exit(0);
      }
   }

   public void errorText(String var1) {
   }
}
