import java.awt.Component;
import java.awt.Container;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.Label;
import java.awt.TextComponent;
import java.util.Locale;

public class Utility {
   public static final Font titleFont = new Font("TimesRoman", 1, 18);
   public static final Font labelFont = new Font("TimesRoman", 1, 14);
   public static final Font choiceFont = new Font("Helvetica", 1, 12);
   public static final Font editFont = new Font("Helvetica", 0, 14);
   public static final Font creditFont = new Font("Helvetica", 0, 10);
   private static Locale[] localeList = new Locale[]{new Locale("DA", "DK", ""), new Locale("EN", "US", ""), new Locale("EN", "GB", ""), new Locale("EN", "CA", ""), new Locale("FR", "FR", ""), new Locale("FR", "CA", ""), new Locale("DE", "DE", ""), new Locale("IT", "IT", ""), new Locale("JA", "JP", "")};

   public static void fixGrid(Container var0, int var1) {
      GridBagLayout var2 = new GridBagLayout();
      var0.setLayout(var2);
      GridBagConstraints var3 = new GridBagConstraints();
      var3.fill = 3;
      var3.weightx = (double)1.0F;
      var3.insets = new Insets(2, 2, 2, 2);
      Component[] var4 = var0.getComponents();

      for(int var5 = 0; var5 < var4.length; ++var5) {
         int var10000 = var5 % var1;
         var3.gridwidth = 1;
         if (var5 % var1 == var1 - 1) {
            var3.gridwidth = 0;
         }

         if (var4[var5] instanceof Label) {
            switch (((Label)var4[var5]).getAlignment()) {
               case 0:
                  var3.anchor = 17;
                  break;
               case 1:
                  var3.anchor = 10;
                  break;
               case 2:
                  var3.anchor = 13;
            }
         }

         var2.setConstraints(var4[var5], var3);
      }

   }

   public static void setInsets(Container var0, Component var1, Insets var2) {
      GridBagLayout var3 = (GridBagLayout)var0.getLayout();
      GridBagConstraints var4 = var3.getConstraints(var1);
      var4.insets = var2;
      var3.setConstraints(var1, var4);
   }

   public static void setText(TextComponent var0, String var1) {
      String var2 = var0.getText();
      if (!var2.equals(var1)) {
         var0.setText(var1);
      }
   }

   public static Locale[] getG7Locales() {
      return localeList;
   }
}
